<!-- #include file="inc.common.asp" -->
<%
	
	' many users does not read the included README.TXT file before trying to 
	' set up this chat -- in order to help them a bit we check if we have the
	' required objects properly initialised
	On Error Resume Next
	If (NOT IsObject(conquerChatUsers) OR NOT IsObject(conquerChatRooms)) Then
		Response.Redirect("errorInSetup.asp")
		Response.End
	End If
	
	Dim userId
	
	Dim mode, errorMessage
	mode = Request("mode")
	
	If (mode = "userLogin") Then
		
		Dim userName
		userName = Server.HTMLEncode(Request("username"))
		
		If (countUsers() >= USERS) Then
			errorMessage = getMsg("error.maximum_users_reached")
		ElseIf (Len(userName) = 0)  Then
			errorMessage = getMsg("error.missing_username")
		ElseIf (Len(userName) > MAX_USERNAME_LENGTH) Then
			errorMessage = getMsg("error.username_length_exceeded", MAX_USERNAME_LENGTH)
		ElseIf (userExists(userName)) Then
			errorMessage = getMsg("error.username_in_use")
		ElseIf (NOT isValidUsername(userName)) Then
			errorMessage = getMsg("error.invalid_username")
		ElseIf (isUserNameBlocked(userName)) Then
			errorMessage = getMsg("error.username_blocked")
		Else
			
			Dim p
			Set p = New Person
			p.id = -1
			p.name = userName
			p.roomId = 0
			p.ipAddress = Request.ServerVariables("REMOTE_ADDR")
			
			' we have a new chat user thus we need to create a new
			' id for him/her
			Set p = addUser(p)
			
			' tell all other users about this new user
			Call addMessage( _
				p.id, _
				"-1", _
				"<span class=LoggedIn><img src='images/new.gif' height=9 width=9>&nbsp;" & getMsg("user.logged_on", p.name, Now()) & "</span><br>" _
			)
			
			Session("user") = p.data
			
			' redirect to new frame window and create a new user login
			Response.Redirect("frames.asp")
			Response.End
			
		End If
		
	End If ' > If (mode = "userLogin") Then
	
	' make sure we don't show any inactive users for new chat users
	kickInactiveUsers()
	
	'If (conquerChatRooms.Count = 0) Then
	'	setupRooms()
	'End If
	
%>
<html>
<head>
	<title><%= APPLICATION_NAME %></title>
	<link rel="stylesheet" type="text/css" href="css/chat.css">
	<script language="JavaScript1.2" type="text/javascript">
	<!--
		
		function init() {
			
			// set focus on 'username' field
			f = document.frmLogin;
			if (typeof f != 'undefined' && typeof f.username != 'undefined') {
				f.username.select();
				f.username.focus();
			}
		}
		
	// -->
	</script>
</head>

<body background="#FFFFFF" onLoad="init()" topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">
			
		<table width=100% border=0 cellspacing=0 cellpadding=4>
		<% If (countUsers() <> 0) Then %>
		<tr>
			<td class=uo colspan=3>
				<%= getMsg("login.users_logged_on", countUsers(), USERS) %>
			</td>
		</tr>
		<tr>
			<th class=uo width="1%">&nbsp;</th>
			<th class=uo><%= getMsg("login.header.username") %></th>
			<th class=uo><%= getMsg("login.header.room") %></th>
		</tr>
		<%
			
			' display all users and their associated rooms
			
			Dim user, room_
			For Each userId In conquerChatUsers
				
				Set user = getUser(userId)
				Set room_ = getRoom(user.roomId)
				If (room_ Is Nothing) Then
					Set room_ = New Room
					room_.name = "N/A"
				End If
				
				Response.Write("<tr>")
				Response.Write(" 	<td class=uo><nobr><img src='images/transparent.gif' width=8 height=16><img src='images/member.gif' width=16 height=16 border=0></nobr></td>")
				Response.Write(" 	<td class=uo>" & user.name & "</td>")
				Response.Write(" 	<td class=uo>" & Server.HTMLEncode(room_.name) & "</td>" & vbCrLf)
				Response.Write("</tr>")
				
			Next
			
		Else %>
		<tr>
			<td class=uo colspan=3>&nbsp;<%= getMsg("login.no_users_online") %></td>
		</tr>
		<% End If %>
		</table>

</body>
</html>