<% 
'#################################################################################
'## Snitz Forums 2000 v3.4.04
'#################################################################################
'## Copyright (C) 2000-04 Michael Anderson, Pierre Gorissen,
'##                       Huw Reddick and Richard Kinser
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or (at your option) any later version.
'##
'## All copyright notices regarding Snitz Forums 2000
'## must remain intact in the scripts and in the outputted HTML
'## The "powered by" text/logo with a link back to
'## http://forum.snitz.com in the footer of the pages MUST
'## remain visible when the pages are viewed on the internet or intranet.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public License
'## along with this program; if not, write to the Free Software
'## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'##
'## Support can be obtained from our support forums at:
'## http://forum.snitz.com
'##
'## Correspondence and Marketing Questions can be sent to:
'## manderson@snitz.com
'##
'#################################################################################


function EmailField(fTestString) 
	TheAt = Instr(2, fTestString, "@")
	if TheAt = 0 then 
		EmailField = 0
	else
		TheDot = Instr(cLng(TheAt) + 2, fTestString, ".")
		if TheDot = 0 then
			EmailField = 0
		else
			if cLng(TheDot) + 1 > Len(fTestString) then
				EmailField = 0
			else
				EmailField = -1
			end if
		end if
	end if
end function 


'##############################################
'##            Ranks and Stars               ##
'##############################################

function getMember_Level(fM_TITLE, fM_LEVEL, fM_POSTS)
	dim Member_Level

	Member_Level = ""
	if Trim(fM_TITLE) <> "" then
		Member_Level = fM_TITLE
	else
		select case fM_LEVEL
			case "1"  
				if (fM_POSTS < cLng(intRankLevel1)) then Member_Level = Member_Level & strRankLevel0
				if (fM_POSTS >= cLng(intRankLevel1)) and (fM_POSTS < cLng(intRankLevel2)) then Member_Level = Member_Level & strRankLevel1
				if (fM_POSTS >= cLng(intRankLevel2)) and (fM_POSTS < cLng(intRankLevel3)) then Member_Level = Member_Level & strRankLevel2
				if (fM_POSTS >= cLng(intRankLevel3)) and (fM_POSTS < cLng(intRankLevel4)) then Member_Level = Member_Level & strRankLevel3
				if (fM_POSTS >= cLng(intRankLevel4)) and (fM_POSTS < cLng(intRankLevel5)) then Member_Level = Member_Level & strRankLevel4
				if (fM_POSTS >= cLng(intRankLevel5)) then Member_Level = Member_Level & strRankLevel5
			case "2"
				Member_Level = Member_Level & strRankMod
			case "3"
				Member_Level = Member_Level & strRankAdmin
			case else  
				Member_Level = Member_Level & "Error" 
		end select
	end if
	
	getMember_Level = Member_Level
end function

function NewRank(ByVal strStarsConfig, ByVal intRank, ByVal intMaxStars)
      dim intNewRank
      Select Case strStarsConfig
       Case "0"
        intNewRank = intRank
       Case "1"
        intNewRank = 1
       Case "2"
        intNewRank = intMaxStars
        if intRank < intNewRank then intNewRank = intRank + 1
       Case "3"
        intNewRank = intMaxStars
      End select
      NewRank = intNewRank
end function

function getStar_Level(ByVal fM_ID, ByVal fM_LEVEL, ByVal fM_POSTS)
		  dim strStarImage, intRank, strStar_Level
		  dim intStarCount, strNewRankColor, arrRankLevels, arrRankColors
		  dim intMaxStars, intBonusPosts, intBonusRank
		  Rem -Set Maximum Number of Stars
		  intMaxStars = clng(strMaxStars)
		  strStar_Level = ""
		  arrRankLevels = array(intRankLevel1,intRankLevel2,intRankLevel3,intRankLevel4,intRankLevel5)
		  arrRankColors = array(strRankColor1,strRankColor2,strRankColor3,strRankColor4,strRankColor5)
		  for intRank = 0 to 4
		  	if (fM_POSTS < cint(arrRankLevels(intRank))) then exit for
		  next
		  Rem -User has reached the number of posts set for level Five
		  Rem -Will get an additional star
		  Rem -when his/her posts go up by the number of posts set for level Five 
		  if intRank = 5 then
		    intBonusRank = 0
		    intBonusPosts = clng(fM_POSTS - (cint(intRankLevel5)))
		    if intBonusPosts > 0 then intBonusRank = (intBonusPosts\(cint(intrankLevel5)))
		    'intRank = intRank + intBonusRank
		  end if
		  arrRankLevels = empty 
		  Select case fM_LEVEL
		  	Case "1"
		  		Rem -No Star to Normal Members if their posts are less then First Level
		  		if intRank = 0 then getStar_Level = strStar_Level : exit function
		  		strNewRankColor = arrRankColors(intRank - 1)
		  	 if intRank <= intMaxStars then intMaxStars = intRank
		  	Case "2"
		  		strNewRankColor = strRankColorMod
		  		intMaxStars = NewRank(strModStars, intRank, intMaxStars)
		  	Case "3"
		  		strNewRankColor = strRankColorAdmin
      intMaxStars = NewRank(strAdminStars, intRank, intMaxStars)
      Rem -Give An Extra Star to Super Admin
      if fM_ID = intAdminMemberID then intMaxStars = intMaxStars + 1
		   Case else
		  		getStar_Level = strStar_Level & "Error"
		  		exit function
		  end select
		  arrRankColors = empty
		  strStarImage = getCurrentIcon(strIconStar & strNewRankColor & ".gif||", "", "")
		  for intStarCount = 1 to intMaxStars
		  	strStar_Level =  strStar_Level & strStarImage
		  next
		  getStar_Level = strStar_Level
		  strStarImage = "" :	strStar_Level = ""
		  intRank = 0 :	intStarCount = 0
end function


function getStarColor(strStarColor)
	select case strStarColor
		case "gold"   : getStarColor = strIconStarGold
		case "silver" : getStarColor = strIconStarSilver
		case "bronze" : getStarColor = strIconStarBronze
		case "orange" : getStarColor = strIconStarOrange
		case "red"    : getStarColor = strIconStarRed
		case "purple" : getStarColor = strIconStarPurple
		case "blue"   : getStarColor = strIconStarBlue
		case "cyan"   : getStarColor = strIconStarCyan
		case "green"  : getStarColor = strIconStarGreen
	end select
end function


function getSig(fUser_Name)
	'## Forum_SQL
	strSql = "SELECT M_SIG "
	strSql = strSql & " FROM " & strMemberTablePrefix & "MEMBERS "
	strSql = strSql & " WHERE " & strDBNTSQLName & " = '" & ChkString(fUser_Name, "SQLString") & "'"

	set rsSig = my_Conn.Execute (strSql)

	if rsSig.EOF or rsSig.BOF then
		'## Do nothing
	else
		getSig = rsSig("M_SIG")
	end if

	rsSig.close
	set rsSig = nothing
end function


function ViewSig(fUserID)
	if fUserID = -1 then
		ViewSig = 1
		exit function
	end if

	'## Forum_SQL
	strSqlv = "SELECT M_VIEW_SIG "
	strSqlv = strSqlv & " FROM " & strMemberTablePrefix & "MEMBERS "
	strSqlv = strSqlv & " WHERE MEMBER_ID = " & cLng(fUserID)

	set rsVSig = my_Conn.Execute (strSqlv)

	if rsVSig.EOF or rsVSig.BOF then
		ViewSig = 1
	else
		ViewSig = rsVSig("M_VIEW_SIG")
	end if

	rsVSig.close
	set rsVSig = nothing
end function


function getSigDefault(fUserID)
	if fUserID = -1 then
		getSigDefault = 1
		exit function
	end if

	if Session(strCookieURL & "intSigDefault" & MemberID) = "" or IsNull(Session(strCookieURL & "intSigDefault" & MemberID)) then
		'on error resume next
		strSqld = "SELECT M_SIG_DEFAULT "
		strSqld = strSqld & " FROM " & strMemberTablePrefix & "MEMBERS "
		strSqld = strSqld & " WHERE MEMBER_ID = " & cLng(fUserID)

		set rsSigDefault = my_Conn.Execute (strSqld)

		if rsSigDefault.EOF or rsSigDefault.BOF then
			getSigDefault = 1
			set rsSigDefault = nothing
			exit function
		else
			tmpSigDefault = rsSigDefault("M_SIG_DEFAULT")
			Session(strCookieURL & "intSigDefault" & MemberID) = tmpSigDefault
			Session(strCookieURL & "intSigDefault" & MemberID) = tmpSigDefault
		end if

		set rsSigDefault = nothing
	end if
	if Session(strCookieURL & "intSigDefault" & MemberID) <> "" then
		getSigDefault = Session(strCookieURL & "intSigDefault" & MemberID)
	else
		getSigDefault = 1
	end if
end function


Function DisplayUsersAge(fDOB)
	dtDOB = fDOB
	dtToday = FormatDateTime(strForumTimeAdjust,2)
	DisplayUsersAge = DateDiff("yyyy", dtDOB, dtToday)
	dtTmp = DateAdd("yyyy", DisplayUsersAge, dtDOB)
	if (DateDiff("d", dtToday, dtTmp) > 0) then DisplayUsersAge = DisplayUsersAge - 1
End Function


function DOBToDate(fDOB)
	'Testing for server format
	if strComp(Month("04/05/2002"),"4") = 0 then
		DOBToDate = cdate("" & Mid(fDOB, 5,2) & "/" & Mid(fDOB, 7,2) & "/" & Mid(fDOB, 1,4) & "")
	else
		DOBToDate = cdate("" & Mid(fDOB, 7,2) & "/" & Mid(fDOB, 5,2) & "/" & Mid(fDOB, 1,4) & "")
	end if
end function

'##############################################
'##            Hover Color MOD               ##
'##############################################
'Response.Write	"    <script language=""JavaScript"" type=""text/javascript"">" & vbNewLine & _
'		"    <!-- hide from JavaScript-challenged browsers" & vbNewLine & _
'		"    function mOvr(src,clrOver) {if (!src.contains(event.fromElement))  {src.bgColor = clrOver;}}" & vbNewLine & _
'		"    function mOut(src,clrIn)   {if (!src.contains(event.toElement))    {src.style.cursor = 'default'; src.bgColor = clrIn;}}" & vbNewLine & _
'		"    // --->" & vbNewLine &_
'		"    </script>" & vbNewLine
		
Response.Write	"<script language=""JavaScript"" type=""text/javascript"">" & vbNewLine & _
		"<!-- hide from JavaScript-challenged browsers" & vbNewLine & _
		"function mOvr(src,clrOver) {src.bgColor = clrOver;}" & vbNewLine & _
		"function mOut(src,clrIn)   {src.style.cursor = 'default'; src.bgColor = clrIn;}" & vbNewLine & _
		"// --->" & vbNewLine & _
		"</script>" & vbNewLine

'Rem User Field Code ####################################### 
function DoesUserFieldExist(fMemberID,FUSerFieldID)

	fieldSQL = "SELECT * FROM " & strMemberTablePrefix & "MEMBERFIELDS WHERE " & strMemberTablePrefix & "MEMBERFIELDS.USR_FIELD_ID=" & FUSerFieldID 
	fieldSQL = fieldSQL & " AND " & strMemberTablePrefix & "MEMBERFIELDS.MEMBER_ID=" & fMemberID
	set rsGetFields = my_Conn.Execute(fieldSQL)
	DoesUserFieldExist = not rsGetFields.EOF
	rsGetFields.Close

end function

function getUserFieldValue(fUser_Field_ID,fMemberID)

	strSql = "SELECT " & strMemberTablePrefix & "MEMBERFIELDS.USR_VALUE "
	strSql = strSql & " FROM " & strMemberTablePrefix & "MEMBERFIELDS "
	strSql = strSql & " WHERE " & strMemberTablePrefix & "MEMBERFIELDS.USR_FIELD_ID = " & fUser_Field_ID
	strSql = strSql & " AND " & strMemberTablePrefix & "MEMBERFIELDS.MEMBER_ID = " & fMemberID 
	set rsgetUserFieldValue = my_Conn.Execute(strSql)
	if Not rsgetUserFieldValue.EOF then
		getUserFieldValue = rsgetUserFieldValue("USR_VALUE")
	else
		getUserFieldValue = ""
	end if

end function
'Rem User Field Code #######################################
%>